'     **** CONVERTING A FILE (BASE-256 NUMBER) TO BASE-10 ****

'Start with the leftmost byte; repeatedly multiply its ASC value by 256
'and add the next byte's ASC value until all the bytes have been used.
'The process is shown in detail below, to demonstrate how this method
'produces the correct results with 3 bytes:
'
' A,H and W (ASC values 65, 72 and 87 respectively):
'
' first ASC byte (65)   :      65
' multiply by 256       :   16640
' add next ASC byte (72):   16712
' multiply by 256       : 4278272
' add next ASC byte (87): 4278359
'
' My Algorithm is recording the Base-10 Number BACKWARDS and then
' REVERSING the file so that the Base-10 Number is shown MSB<-->LSB
'
DEFINT A-Z
VIEW PRINT
COLOR 14
CLS
LOCATE 1, 20
COLOR 9
PRINT "BASE256 FILE TO BASE10 FILE CONVERTER"
LOCATE 3, 2, 1
COLOR 15
PRINT "EXISTING FileName: ";
COLOR 14
LINE INPUT ; InFile$
InFile$ = LTRIM$(RTRIM$(InFile$))
IF InFile$ = "" THEN
    VIEW PRINT
    COLOR 7, 0
    CLS
    SYSTEM
END IF
IF _FILEEXISTS(InFile$) = 0 THEN
    RUN
END IF
InFile = FREEFILE
OPEN InFile$ FOR BINARY AS InFile
LOCATE 5, 2
COLOR 15
PRINT "FileLength:";
COLOR 14
PRINT LOF(InFile); "Bytes";
'
Lab1:
'
VIEW PRINT 7 TO 24
CLS
LOCATE 7, 2, 1
COLOR 15
Base10FileLength# = FIX(LOF(InFile) * 2.4)
PRINT "OutPut FileName w/Approximate Length"; Base10FileLength#; "Bytes: ";
COLOR 14
LINE INPUT ; OutFile$
OutFile$ = LTRIM$(RTRIM$(OutFile$))
IF OutFile$ = "" THEN
    CLOSE
    RUN
END IF
IF _FILEEXISTS(OutFile$) THEN
    SavedCounter$ = OutFile$ + ".bin"
    IF _FILEEXISTS(SavedCounter$) THEN
        SavedCounter = FREEFILE
        OPEN SavedCounter$ FOR BINARY AS SavedCounter LEN = 4
        Counter$ = STRING$(4, 32)
        GET #SavedCounter, , Counter$
        Counter& = CVL(Counter$)
        CLOSE SavedCounter
    ELSE
        GOTO Lab1
    END IF
END IF
OutFile = FREEFILE
OPEN OutFile$ FOR BINARY AS OutFile
LOCATE 24, 26
COLOR 15
PRINT "Hit ";
COLOR 31
PRINT "<Esc>";
COLOR 15
PRINT " to Quit (For Now)";
VIEW PRINT 13 TO 23
CLS
LOCATE 13, 2
COLOR 15
PRINT "Base256 File Byte Number:";
LOCATE 15, 3
PRINT "Base10 File Byte Number:";
COLOR 14
InString$ = STRING$(LOF(InFile), 32)
GET #InFile, , InString$
CLOSE InFile
IF Counter& THEN
    GOTO EnterLoop
END IF
Counter& = 1
'
FirstLoop:
'
InBuffer$ = MID$(InString$, Counter&, 1)
OutBuffer = ASC(InBuffer$)
IF OutBuffer = 0 THEN
    OutBuffer$ = "0"
    PUT #OutFile, , OutBuffer$
    Counter& = Counter& + 1
    GOTO FirstLoop
END IF
IF OutBuffer < 10 THEN
    OutBuffer$ = RIGHT$(STR$(OutBuffer), 1)
ELSEIF OutBuffer < 100 THEN
    OutBuffer$ = RIGHT$(STR$(OutBuffer), 1) + MID$(STR$(OutBuffer), 2, 1)
ELSE
    OutBuffer$ = RIGHT$(STR$(OutBuffer), 1) + MID$(STR$(OutBuffer), 3, 1) + MID$(STR$(OutBuffer), 2, 1)
END IF
PUT #OutFile, , OutBuffer$
Counter& = Counter& + 1
Carry = 0
DO
    '*************************(MULTIPLY BY 256)*********************
    '
    EnterLoop:
    '
    OutFileFull& = FIX(LOF(OutFile) / 2097152)
    IF OutFileFull& THEN
        OutBuffer$ = STRING$(2097152, 32)
    END IF
    OutFileRemainder& = LOF(OutFile) - (2097152 * OutFileFull&)
    SEEK #OutFile, 1
    FOR A& = 1 TO OutFileFull&
        OutFileByte& = SEEK(OutFile)
        GET #OutFile, OutFileByte&, OutBuffer$
        FOR X& = 1 TO 2097152
            Multiply = 256 * VAL(MID$(OutBuffer$, X&, 1)) + Carry
            MID$(OutBuffer$, X&, 1) = RIGHT$(STR$(Multiply), 1)
            IF LEN(STR$(Multiply)) = 6 THEN
                Carry$ = MID$(STR$(Multiply), 2, 4)
            ELSEIF LEN(STR$(Multiply)) = 5 THEN
                Carry$ = MID$(STR$(Multiply), 2, 3)
            ELSEIF LEN(STR$(Multiply)) = 4 THEN
                Carry$ = MID$(STR$(Multiply), 2, 2)
            ELSEIF LEN(STR$(Multiply)) = 3 THEN
                Carry$ = MID$(STR$(Multiply), 2, 1)
            ELSE
                Carry$ = "0"
            END IF
            Carry = VAL(Carry$)
        NEXT X&
        PUT #OutFile, OutFileByte&, OutBuffer$
    NEXT A&
    IF OutFileRemainder& THEN
        OutBuffer$ = STRING$(OutFileRemainder&, 32)
        OutFileByte& = SEEK(OutFile)
        GET #OutFile, OutFileByte&, OutBuffer$
        FOR X& = 1 TO OutFileRemainder&
            Multiply = 256 * VAL(MID$(OutBuffer$, X&, 1)) + Carry
            MID$(OutBuffer$, X&, 1) = RIGHT$(STR$(Multiply), 1)
            IF LEN(STR$(Multiply)) = 6 THEN
                Carry$ = MID$(STR$(Multiply), 2, 4)
            ELSEIF LEN(STR$(Multiply)) = 5 THEN
                Carry$ = MID$(STR$(Multiply), 2, 3)
            ELSEIF LEN(STR$(Multiply)) = 4 THEN
                Carry$ = MID$(STR$(Multiply), 2, 2)
            ELSEIF LEN(STR$(Multiply)) = 3 THEN
                Carry$ = MID$(STR$(Multiply), 2, 1)
            ELSE
                Carry$ = "0"
            END IF
            Carry = VAL(Carry$)
        NEXT X&
        PUT #OutFile, OutFileByte&, OutBuffer$
    END IF
    IF Carry > 0 THEN
        IF LEN(STR$(Multiply)) = 6 THEN
            Carry$ = MID$(STR$(Multiply), 5, 1) + MID$(STR$(Multiply), 4, 1) + MID$(STR$(Multiply), 3, 1) + MID$(STR$(Multiply), 2, 1)
        ELSEIF LEN(STR$(Multiply)) = 5 THEN
            Carry$ = MID$(STR$(Multiply), 4, 1) + MID$(STR$(Multiply), 3, 1) + MID$(STR$(Multiply), 2, 1)
        ELSEIF LEN(STR$(Multiply)) = 4 THEN
            Carry$ = MID$(STR$(Multiply), 3, 1) + MID$(STR$(Multiply), 2, 1)
        ELSEIF LEN(STR$(Multiply)) = 3 THEN
            Carry$ = MID$(STR$(Multiply), 2, 1)
        END IF
        Carry = VAL(Carry$)
    END IF
    IF Carry THEN
        OutBuffer$ = Carry$
        PUT #OutFile, LOF(OutFile) + 1, OutBuffer$
    END IF
    Carry = 0
    '***************************(ADD)************************
    InBuffer$ = MID$(InString$, Counter&, 1)
    InBuffer = ASC(InBuffer$)
    Counter& = Counter& + 1
    OutFileFull& = FIX(LOF(OutFile) / 2097152)
    IF OutFileFull& THEN
        OutBuffer$ = STRING$(2097152, 32)
    END IF
    OutFileRemainder& = LOF(OutFile) - (2097152 * OutFileFull&)
    SEEK #OutFile, 1
    FOR A& = 1 TO OutFileFull&
        OutFileByte& = SEEK(OutFile)
        GET #OutFile, OutFileByte&, OutBuffer$
        Added = InBuffer + VAL(MID$(OutBuffer$, 1, 1)) + Carry
        MID$(OutBuffer$, 1, 1) = RIGHT$(STR$(Added), 1)
        IF Added > 99 THEN
            Carry$ = MID$(STR$(Added), 2, 2)
        ELSEIF Added > 9 THEN
            Carry$ = MID$(STR$(Added), 2, 1)
        ELSE
            Carry$ = "0"
        END IF
        Carry = VAL(Carry$)
        IF Carry = 0 THEN
            PUT #OutFile, OutFileByte&, OutBuffer$
            GOTO Bypass
        END IF
        FOR Y& = 2 TO 2097152
            Added = VAL(MID$(OutBuffer$, Y&, 1)) + Carry
            MID$(OutBuffer$, Y&, 1) = RIGHT$(STR$(Added), 1)
            IF Added > 99 THEN
                Carry$ = MID$(STR$(Added), 2, 2)
            ELSEIF Added > 9 THEN
                Carry$ = MID$(STR$(Added), 2, 1)
            ELSE
                Carry$ = "0"
            END IF
            Carry = VAL(Carry$)
            IF Carry = 0 THEN
                PUT #OutFile, OutFileByte&, OutBuffer$
                GOTO Bypass
            END IF
        NEXT Y&
        PUT #OutFile, OutFileByte&, OutBuffer$
    NEXT A&
    IF OutFileRemainder& THEN
        OutBuffer$ = STRING$(OutFileRemainder&, 32)
        OutFileByte& = SEEK(OutFile)
        GET #OutFile, OutFileByte&, OutBuffer$
        Added = InBuffer + VAL(MID$(OutBuffer$, 1, 1)) + Carry
        MID$(OutBuffer$, 1, 1) = RIGHT$(STR$(Added), 1)
        IF Added > 99 THEN
            Carry$ = MID$(STR$(Added), 2, 2)
        ELSEIF Added > 9 THEN
            Carry$ = MID$(STR$(Added), 2, 1)
        ELSE
            Carry$ = "0"
        END IF
        Carry = VAL(Carry$)
        IF Carry = 0 THEN
            PUT #OutFile, OutFileByte&, OutBuffer$
            GOTO Bypass
        END IF
        FOR Y& = 2 TO OutFileRemainder&
            Added = VAL(MID$(OutBuffer$, Y&, 1)) + Carry
            MID$(OutBuffer$, Y&, 1) = RIGHT$(STR$(Added), 1)
            IF Added > 99 THEN
                Carry$ = MID$(STR$(Added), 2, 2)
            ELSEIF Added > 9 THEN
                Carry$ = MID$(STR$(Added), 2, 1)
            ELSE
                Carry$ = "0"
            END IF
            Carry = VAL(Carry$)
            IF Carry = 0 THEN
                PUT #OutFile, OutFileByte&, OutBuffer$
                GOTO Bypass
            END IF
        NEXT Y&
        PUT #OutFile, OutFileByte&, OutBuffer$
    END IF
    IF Carry THEN
        OutBuffer$ = RIGHT$(STR$(Carry), 1)
        PUT #OutFile, LOF(OutFile) + 1, OutBuffer$
    END IF
    '
    Bypass:
    '
    LOCATE 13, 28, 0
    PRINT Counter&;
    LOCATE 15, 28
    PRINT LOF(OutFile);
    DO
        _LIMIT 30
        An$ = INKEY$
        IF LEN(An$) THEN
            IF An$ = CHR$(27) THEN
                SavedCounter$ = OutFile$ + ".bin"
                SavedCounter = FREEFILE
                OPEN SavedCounter$ FOR BINARY AS SavedCounter LEN = 4
                Counter$ = MKL$(Counter&)
                PUT #SavedCounter, 1, Counter$
                CLOSE
                CLEAR
                SYSTEM
            END IF
            EXIT DO
        END IF
        EXIT DO
    LOOP
LOOP UNTIL Counter& = LEN(InString$) + 1
LOCATE 17, 1
COLOR 15
PRINT "Reversing Base10 File";
COLOR 14
PRINT " FROM ";
COLOR 15
PRINT "LSB <> MSB";
COLOR 14
PRINT " TO ";
COLOR 15
PRINT "MSB <> LSB, Byte:";
COLOR 14
X& = 1
Y& = LOF(OutFile)
OutBuffer$ = STRING$(1, 32)
InBuffer$ = STRING$(1, 32)
DO UNTIL X& >= Y&
    GET #OutFile, X&, OutBuffer$
    GET #OutFile, Y&, InBuffer$
    PUT #OutFile, X&, InBuffer$
    PUT #OutFile, Y&, OutBuffer$
    LOCATE 17, 62
    PRINT X&;
    X& = X& + 1
    Y& = Y& - 1
LOOP
CLOSE OutFile
SavedCounter$ = OutFile$ + ".bin"
IF _FILEEXISTS(SavedCounter$) THEN
    KILL SavedCounter$
END IF
CLEAR
SYSTEM






